<template>
  <div>
    <h5>
      <b-row
        align-v="center"
        :class="{ grayed: applicationProfileLabel === '' }"
      >
        <b-col cols="auto" class="text-start me-auto">
          {{
            applicationProfileLabel !== ""
              ? applicationProfileLabel
              : $t("noNameSet")
          }}
        </b-col>
        <b-col cols="auto" align-self="end" class="text-end">
          <b-button @click="openEditModal"><i-bi-gear-fill /></b-button>
          <b-button class="codeButton" @click="switchInteractivity">
            <i-bi-code-slash v-if="interactive" />
            <i-bi-list v-if="!interactive" />
          </b-button>
        </b-col>
      </b-row>
    </h5>
    <div
      v-if="
        interactive &&
        !queryingApplicationProfile &&
        Object.keys(completeApplicationProfile.inheritedParts).length > 0
      "
    >
      <hr />
      <div class="d-grid gap-2">
        <b-button
          :class="(inheritanceVisible ? null : 'collapsed') + ' collapseButton'"
          :aria-expanded="inheritanceVisible ? 'true' : 'false'"
          aria-controls="collapse-value"
          @click="inheritanceVisible = !inheritanceVisible"
        >
          {{ $t("inheritanceVisible") }}
        </b-button>
      </div>
      <b-collapse
        id="collapse-inheritance"
        v-model="inheritanceVisible"
        class="mt-2"
      >
        <b-card>
          <h6>{{ $t("currentAP") }}</h6>
          <b-list-group v-show="interactive && !queryingApplicationProfile">
            <b-button-group class="noBorderRadius">
              <b-list-group-item
                button
                :class="'d-flex justify-content-between align-items-center'"
                :disabled="
                  !interactive ||
                  applicationProfileBaseUrl === baseApplicationProfile.base_url
                "
                :active="
                  applicationProfileBaseUrl === baseApplicationProfile.base_url
                "
                @click="
                  switchDisplayedApplicationProfile(
                    baseApplicationProfile.base_url,
                  )
                "
              >
                <div>
                  {{
                    getApplicationProfileLabelByLocale(
                      baseApplicationProfile,
                      baseDefinition,
                    )
                  }}
                </div>
              </b-list-group-item>
            </b-button-group>
          </b-list-group>
          <hr />
          <h6>{{ $t("inheritedAPs") }}</h6>
          <b-list-group v-show="interactive && !queryingApplicationProfile">
            <b-button-group
              v-for="entry in Object.keys(
                completeApplicationProfile.inheritedParts,
              )"
              :key="entry"
              class="noBorderRadius"
            >
              <b-list-group-item
                button
                :class="'d-flex justify-content-between align-items-center'"
                :disabled="!interactive || applicationProfileBaseUrl === entry"
                :active="applicationProfileBaseUrl === entry"
                @click="switchDisplayedApplicationProfile(entry)"
              >
                <div>
                  {{
                    getApplicationProfileLabelByLocale(
                      completeApplicationProfile.inheritedParts[entry]
                        .applicationProfile,
                      completeApplicationProfile.inheritedParts[entry]
                        .definition,
                    )
                  }}
                </div>
              </b-list-group-item>
            </b-button-group>
          </b-list-group>
        </b-card>
      </b-collapse>
    </div>
    <hr />
    <b-list-group v-show="interactive && !queryingApplicationProfile">
      <b-button-group
        v-for="entry in pathList"
        :key="entry.subject.value"
        v-b-tooltip.hover.noninteractive.top="{
          customClass: 'apTooltip',
          title: entry.object.value,
        }"
        class="noBorderRadius"
      >
        <b-list-group-item
          :id="'ap' + entry.object.value.replace(/[\/.#:]/g, '')"
          :active="selectedProperty === entry.subject"
          button
          :class="
            'd-flex justify-content-between align-items-center' +
            (selectedProperty === entry.subject ? ' active' : '')
          "
          @click="selectProperty(entry)"
        >
          <div
            v-for="name in getEntryLabel(entry, definition)"
            :key="name.object.value"
          >
            {{ name.object.value }}
          </div>
        </b-list-group-item>
        <button
          :class="'list-group-item btn-danger' + (readonly ? ' disabled' : '')"
          :disabled="readonly"
          @click="removeProperty(entry)"
        >
          x
        </button>
      </b-button-group>
      <div v-if="pathList.length === 0" class="grayed">
        {{ $t("emptyPathList") }}
      </div>
    </b-list-group>
    <ListGroupSkeletons v-show="interactive && queryingApplicationProfile" />
    <b-form-textarea
      v-show="!interactive"
      class="rdfView mb-2"
      :disabled="readonly"
      :model-value="textRepresentation"
      @update:modelValue="textDefinitionUpdate"
    />
    <b-form-select
      v-show="!interactive"
      v-model="mimeType"
      :options="mimeTypes"
    />
  </div>
</template>

<script lang="ts">
import { ApplicationProfile } from "@/types/application-profile";
import type { Dataset, Quad, Quad_Subject } from "@rdfjs/types";

import { defineComponent, type PropType } from "vue";

import factory from "rdf-ext";

import {
  getApplicationProfileLabelValue,
  getObject,
  getRDFContentTypes,
  prefixes,
  serializeRDFDefinition,
} from "@/util/linkedData";
import { useDebounceFn } from "@vueuse/core";

// For representing the Code of an AP, these collection of libraries might be interesting: https://github.com/zazuko/rdfjs-elements

export default defineComponent({
  name: "APRepresentation",
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    baseApplicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    baseDefinition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    completeApplicationProfile: {
      required: true,
      type: Object as PropType<{
        definition: Dataset;
        inheritedParts: Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >;
      }>,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    interactive: {
      default: true,
      type: Boolean,
    },
    queryingApplicationProfile: {
      default: false,
      type: Boolean,
    },
    readonly: {
      default: false,
      type: Boolean,
    },
    selectedProperty: {
      required: false,
      default: undefined,
      type: Object as PropType<Quad_Subject | undefined>,
    },
  },
  setup(_, { emit }) {
    const internalRepresentation = ref("");
    const mimeType = ref("text/turtle");

    const textDefinitionUpdate = useDebounceFn((textDefinition: string) => {
      internalRepresentation.value = textDefinition;
      emit(
        "textDefinitionUpdate",
        internalRepresentation.value,
        mimeType.value,
      );
    }, 1000);

    return { internalRepresentation, mimeType, textDefinitionUpdate };
  },
  data() {
    return {
      factory: factory,
      inheritanceVisible: false,
      mimeTypes: [
        { value: "application/ld+json", text: "application/ld+json" },
        { value: "text/turtle", text: "text/turtle" },
      ],
      textRepresentation: "",
    };
  },
  computed: {
    applicationProfileBaseUrl(): string {
      return this.applicationProfile.base_url;
    },
    applicationProfileLabel(): string {
      return this.getApplicationProfileLabelByLocale(
        this.applicationProfile,
        this.definition,
      );
    },
    closed(): boolean {
      for (const entry of this.definition.match(
        factory.namedNode(this.applicationProfileBaseUrl),
        factory.namedNode(prefixes.sh + "closed"),
      )) {
        return entry.object.value === "true";
      }
      return false;
    },
    orders(): Record<string, number> {
      const orderEntities = [
        ...this.definition.match(
          null,
          factory.namedNode(prefixes.sh + "order"),
        ),
      ];
      const orders: Record<string, number> = {};
      for (const orderEntity of orderEntities) {
        orders[orderEntity.subject.value] = Number.parseInt(
          orderEntity.object.value,
        );
        if (Number.isNaN(orders[orderEntity.subject.value])) {
          orders[orderEntity.subject.value] = Number.MAX_VALUE;
        }
      }
      return orders;
    },
    pathList(): Quad[] {
      const propertyObjects = new Set(
        [...this.definition]
          .filter(
            (filterQuad) =>
              filterQuad.subject.value === this.applicationProfileBaseUrl &&
              filterQuad.predicate.value === prefixes.sh + "property",
          )
          .map((temporaryQuad) => temporaryQuad.object.value),
      );
      return [...this.definition]
        .filter(
          (quad) =>
            quad.predicate.value === prefixes.sh + "path" &&
            propertyObjects.has(quad.subject.value),
        )
        .filter(
          (entry) =>
            !this.closed || entry.object.value !== prefixes.rdf + "type",
        )
        .sort((entry1, entry2) => this.compareEntries(entry1, entry2));
    },
  },
  watch: {
    definition() {
      this.serializeDefinition();
    },
    mimeType() {
      this.serializeDefinition();
    },
  },
  created() {
    this.getMimeTypes();
    this.serializeDefinition();
  },
  methods: {
    compareEntries(entry1: Quad, entry2: Quad) {
      let entry1Order: number = Number.MAX_VALUE;
      let entry2Order: number = Number.MAX_VALUE;
      if (entry1.subject.value in this.orders) {
        entry1Order = this.orders[entry1.subject.value];
      }
      if (entry2.subject.value in this.orders) {
        entry2Order = this.orders[entry2.subject.value];
      }
      if (entry1Order === entry2Order) {
        return 0;
      }
      return entry1Order > entry2Order ? 1 : -1;
    },
    async serializeDefinition() {
      this.textRepresentation = await serializeRDFDefinition(
        this.definition,
        this.mimeType,
      );
    },
    openEditModal() {
      this.$emit("openEditModal");
    },
    getApplicationProfileLabelByLocale(
      applicationProfile: ApplicationProfile,
      definition: Dataset,
    ) {
      return getApplicationProfileLabelValue(
        applicationProfile,
        definition,
        this.$i18n.locale,
      );
    },
    getEntryLabel(entry: Quad, definition: Dataset) {
      const localeObject = getObject(
        entry.subject,
        factory.namedNode(prefixes.sh + "name"),
        definition,
        this.$i18n.locale,
      );
      if (localeObject.length > 0) {
        return localeObject;
      }
      // If no name is present, return the entry to render the path url
      return [entry];
    },
    async getMimeTypes() {
      const contentTypes = await getRDFContentTypes();
      this.mimeTypes = [];
      for (const contentType of contentTypes) {
        this.mimeTypes.push({ value: contentType, text: contentType });
      }
    },
    removeProperty(entry: Quad) {
      this.$emit("removeProperty", entry.subject);
    },
    selectProperty(entry: Quad) {
      this.$emit("selectProperty", entry.subject);
    },
    switchDisplayedApplicationProfile(displayedApplicationProfile: string) {
      this.$emit(
        "switchDisplayedApplicationProfile",
        displayedApplicationProfile,
      );
    },
    switchInteractivity() {
      this.$emit("switchInteractivity");
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.noBorderRadius {
  border-radius: 0;
}
.codeButton {
  margin-left: 0.4rem;
}
.grayed {
  color: gray;
}
.rdfView {
  min-height: 60vh;
}
</style>
